package com.bocloud.ims.repository.resource.hmc;

import com.bocloud.ims.entity.resource.hmc.HmdServerHeaPhysicalPort;
import org.springframework.beans.factory.annotation.Lookup;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.Collections;
import java.util.List;
import java.util.Optional;

@Repository
public abstract class HmdServerHeaPhysicalPortRepository extends HmdGenericDao<HmdServerHeaPhysicalPort> {

    @Lookup protected abstract HmdServerHeaRepository serverHeaRepository();

    public HmdServerHeaPhysicalPortRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    @Override
    public void extra(HmdServerHeaPhysicalPort port) {
        Optional.of(port).map(HmdServerHeaPhysicalPort::getHeaId).map(this.serverHeaRepository()::getById).ifPresent(port::setHea);
    }

    public List<HmdServerHeaPhysicalPort> listByServerId(long serverId) {
        return this.search(Collections.singletonMap("a.server_id", serverId));
    }

    public HmdServerHeaPhysicalPort getById(long id) {
        return this.search(Collections.singletonMap("a.id", id)).stream().findFirst().orElse(null);
    }

}
